<?php
/**
 * @file
 * Contains \Drupal\inspect\InspectHelperUnicode.
 */

namespace Drupal\inspect;

use SimpleComplex\Inspect\Helper\Unicode;

/**
 * Unicode helper.
 *
 * @package Drupal\inspect
 */
class InspectHelperUnicode extends Unicode
{
  /**
   * {@inheritDoc}
   */
  public function strlen($var) : int
  {
    $v = '' . $var;
    if ($v === '') {
      return 0;
    }
    return mb_strlen($v);
  }

  /**
   * {@inheritDoc}
   */
  public function strpos($haystack, $needle)
  {
    $hstck = '' . $haystack;
    $ndl = '' . $needle;
    if ($hstck === '' || $ndl === '') {
      return false;
    }
    return mb_strpos($hstck, $ndl);
  }

  /**
   * {@inheritDoc}
   */
  public function substr($var, int $start, ?int $length = null) : string
  {
    if ($start < 0) {
      throw new \InvalidArgumentException('Arg start is not non-negative integer.');
    }
    if ($length !== null && (!is_int($length) || $length < 0)) {
      throw new \InvalidArgumentException('Arg length is not non-negative integer or null.');
    }
    $v = '' . $var;
    if (!$length || $v === '') {
      return '';
    }
    return !$length ? mb_substr($v, $start) : mb_substr($v, $start, $length);
  }

  /**
   * {@inheritDoc}
   */
  public function truncateToByteLength($var, int $length)
  {
    if ($length < 0) {
      throw new \InvalidArgumentException('Arg length is not non-negative integer.');
    }

    $v = '' . $var;
    return \Drupal\Component\Utility\Unicode::truncateBytes($v, $length);
  }
}
